Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/base/Utils.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/base/Utils.java	(revision 136)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/base/Utils.java	(revision 137)
@@ -1,6 +1,6 @@
 package org.txm.partition.core.chartsengine.base;
 
-import org.txm.partition.core.messages.TBXPartitionMessages;
+import org.txm.partition.core.messages.PartitionCoreMessages;
 import org.txm.searchengine.cqp.corpus.Partition;
 
 /**
@@ -24,14 +24,14 @@
 	 */
 	public static String createPartitionDimensionsChartTitle(Partition partition, boolean sortPartsBySize, boolean displayPartsCountInTitle)	{
 
-		String title = TBXPartitionMessages.bind(TBXPartitionMessages.CHARTSENGINE_PARTITION_DIMENSIONS_DIMENSIONS_OF_PARTITION, partition.getName(), partition.getCorpus().getName());
+		String title = PartitionCoreMessages.bind(PartitionCoreMessages.CHARTSENGINE_PARTITION_DIMENSIONS_DIMENSIONS_OF_PARTITION, partition.getName(), partition.getCorpus().getName());
 
 		if(displayPartsCountInTitle)	{
-			title += "\n(" +  partition.getParts().size() + " " + TBXPartitionMessages.CHARTSENGINE_PARTITION_DIMENSIONS_PARTS + ")"; //$NON-NLS-1$ //$NON-NLS-3$
+			title += "\n(" +  partition.getParts().size() + " " + PartitionCoreMessages.CHARTSENGINE_PARTITION_DIMENSIONS_PARTS + ")"; //$NON-NLS-1$ //$NON-NLS-3$
 		}
 
 		if(sortPartsBySize) {
-			title += TBXPartitionMessages.CHARTSENGINE_PARTITION_DIMENSIONS_SORTED_BY_SIZE;
+			title += PartitionCoreMessages.CHARTSENGINE_PARTITION_DIMENSIONS_SORTED_BY_SIZE;
 		}
 
 		return title;
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsPieChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsPieChartCreator.java	(revision 136)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsPieChartCreator.java	(revision 137)
@@ -7,7 +7,7 @@
 import org.txm.chartsengine.jfreechart.core.JFCChartCreator;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.partition.core.chartsengine.base.Utils;
-import org.txm.partition.core.messages.TBXPartitionMessages;
+import org.txm.partition.core.messages.PartitionCoreMessages;
 import org.txm.partition.core.preferences.PartitionDimensionsPreferences;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Part;
@@ -40,7 +40,7 @@
 			// Creating the data set from the partition result
 			DefaultPieDataset dataset = new DefaultPieDataset();
 
-			XYSeries series = new XYSeries(TBXPartitionMessages.CHARTSENGINE_PARTITION_DIMENSIONS_CATEGORY);
+			XYSeries series = new XYSeries(PartitionCoreMessages.CHARTSENGINE_PARTITION_DIMENSIONS_CATEGORY);
 
 			List<Part> parts;
 
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java	(revision 136)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/chartsengine/jfreechart/JFCPartitionDimensionsBarChartCreator.java	(revision 137)
@@ -14,7 +14,7 @@
 import org.txm.chartsengine.jfreechart.core.themes.base.ExtendedNumberAxis;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.partition.core.chartsengine.base.Utils;
-import org.txm.partition.core.messages.TBXPartitionMessages;
+import org.txm.partition.core.messages.PartitionCoreMessages;
 import org.txm.partition.core.preferences.PartitionDimensionsPreferences;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Part;
@@ -47,7 +47,7 @@
 			// Creating the data set from the partition result
 			XYSeriesCollection dataset = new XYSeriesCollection();
 
-			XYSeries series = new XYSeries(TBXPartitionMessages.CHARTSENGINE_PARTITION_DIMENSIONS_CATEGORY);
+			XYSeries series = new XYSeries(PartitionCoreMessages.CHARTSENGINE_PARTITION_DIMENSIONS_CATEGORY);
 			dataset.addSeries(series);
 
 			List<Part> parts;
@@ -76,7 +76,7 @@
 			String title = Utils.createPartitionDimensionsChartTitle(partition, sortPartsBySize, displayPartsCountInTitle);
 
 			// Create the chart
-	        chart = this.getChartsEngine().createXYBarChart(dataset, title, TBXPartitionMessages.CHARTSENGINE_PARTITION_DIMENSIONS_X_AXIS_LABEL, TBXPartitionMessages.CHARTSENGINE_PARTITION_DIMENSIONS_Y_AXIS_LABEL, false, true, false, xAxisSymbols);
+	        chart = this.getChartsEngine().createXYBarChart(dataset, title, PartitionCoreMessages.CHARTSENGINE_PARTITION_DIMENSIONS_X_AXIS_LABEL, PartitionCoreMessages.CHARTSENGINE_PARTITION_DIMENSIONS_Y_AXIS_LABEL, false, true, false, xAxisSymbols);
 	        ((IItemSelectionRenderer) chart.getXYPlot().getRenderer()).setChartType(ChartsEngine.CHART_TYPE_PARTITION_DIMENSIONS);
 
 
Index: tmp/org.txm.partition.core/src/org/txm/partition/core/messages/PartitionCoreMessages.java
===================================================================
--- tmp/org.txm.partition.core/src/org/txm/partition/core/messages/PartitionCoreMessages.java	(revision 0)
+++ tmp/org.txm.partition.core/src/org/txm/partition/core/messages/PartitionCoreMessages.java	(revision 137)
@@ -0,0 +1,26 @@
+package org.txm.partition.core.messages;
+
+import org.eclipse.osgi.util.NLS;
+
+
+
+public class PartitionCoreMessages extends NLS {
+
+	private static final String BUNDLE_NAME = "org.txm.partition.core.messages.messages"; //$NON-NLS-1$
+
+	public static String CHARTSENGINE_CANT_CREATE_PARTITION_DIMENSIONS_FILE_CHART;
+	public static String CHARTSENGINE_PARTITION_DIMENSIONS_SORTED_BY_SIZE;
+	public static String CHARTSENGINE_PARTITION_DIMENSIONS_DIMENSIONS_OF_PARTITION;
+	public static String CHARTSENGINE_PARTITION_DIMENSIONS_PARTS;
+	public static String CHARTSENGINE_PARTITION_DIMENSIONS_CATEGORY;
+	public static String CHARTSENGINE_PARTITION_DIMENSIONS_X_AXIS_LABEL;
+	public static String CHARTSENGINE_PARTITION_DIMENSIONS_Y_AXIS_LABEL;
+
+	static {
+		// initialize resource bundle
+		NLS.initializeMessages(BUNDLE_NAME, PartitionCoreMessages.class);
+	}
+
+	private PartitionCoreMessages() {
+	}
+}

Index: tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/BalanceEditor.java
===================================================================
--- tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/BalanceEditor.java	(revision 136)
+++ tmp/org.txm.textsbalance.rcp/src/org/txm/textsbalance/rcp/editors/BalanceEditor.java	(revision 137)
@@ -16,9 +16,6 @@
 import org.eclipse.swt.widgets.Combo;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Group;
-import org.eclipse.ui.IEditorInput;
-import org.eclipse.ui.IEditorSite;
-import org.eclipse.ui.PartInitException;
 import org.txm.chartsengine.rcp.editors.ChartEditorPart;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.rcpapplication.views.CorporaView;
Index: tmp/org.txm.progression.core/src/org/txm/progression/core/messages/ProgressionCoreMessages.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/messages/ProgressionCoreMessages.java	(revision 0)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/messages/ProgressionCoreMessages.java	(revision 137)
@@ -0,0 +1,40 @@
+package org.txm.progression.core.messages;
+
+import org.eclipse.osgi.util.NLS;
+
+public class ProgressionCoreMessages extends NLS {
+
+	private static final String BUNDLE_NAME = "org.txm.progression.core.messages.messages"; //$NON-NLS-1$
+
+	public static String ChartsEngine_PROGRESSION_X_AXIS_LABEL;
+	public static String ChartsEngine_PROGRESSION_Y_AXIS_CUMULATIVE_LABEL;
+	public static String ChartsEngine_PROGRESSION_Y_AXIS_NOT_CUMULATIVE_LABEL;
+
+	public static String ChartsEngine_PROGRESSION_TITLE_PROGRESSION_OF;
+	public static String ChartsEngine_PROGRESSION_TITLE_IN;
+	public static String ChartsEngine_PROGRESSION_TITLE_DENSITY;
+	public static String ChartsEngine_PROGRESSION_TITLE_STRUCT;
+	public static String ChartsEngine_PROGRESSION_TITLE_PROPERTY;
+	public static String ChartsEngine_PROGRESSION_TITLE_VALUE;
+
+	public static String ComputeProgression_0;
+	public static String ComputeProgression_1;
+	public static String ComputeProgression_2;
+	public static String ComputeProgression_3;
+	public static String ComputeProgression_4;
+	public static String ComputeProgression_5;
+	public static String ComputeProgression_6;
+	public static String ComputeProgression_9;
+	public static String ComputeProgression_10;
+	public static String ComputeProgression_12;
+	public static String ComputeProgression_13;
+
+	
+	static {
+		// initialize resource bundle
+		NLS.initializeMessages(BUNDLE_NAME, ProgressionCoreMessages.class);
+	}
+
+	private ProgressionCoreMessages() {
+	}
+}

Index: tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java	(revision 0)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/functions/Progression.java	(revision 137)
@@ -0,0 +1,665 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate: 2016-09-19 10:31:00 +0200 (Mon, 19 Sep 2016) $
+// $LastChangedRevision: 3298 $
+// $LastChangedBy: mdecorde $ 
+//
+package org.txm.progression.core.functions;
+
+import java.io.BufferedWriter;
+import java.io.File;
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.io.OutputStreamWriter;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.txm.HasResults;
+import org.txm.Messages;
+import org.txm.functions.Function;
+import org.txm.functions.TXMResult;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.CorpusManager;
+import org.txm.searchengine.cqp.corpus.Property;
+import org.txm.searchengine.cqp.corpus.QueryResult;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
+import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.Subcorpus;
+import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.searchengine.cqp.corpus.query.Query;
+import org.txm.searchengine.cqp.serverException.CqiServerError;
+
+/**
+ * Computes a progression similar to the progression of Weblex software.
+ *  
+ * @author mdecorde
+ * @author sjacquot
+ */
+public class Progression extends Function implements TXMResult  {
+
+	/** The corpus. */
+	Corpus corpus;
+
+	/** The queries. */
+	List<Query> queries;
+
+	/** The structure. */
+	StructuralUnit structure;
+
+	/** The property. */
+	StructuralUnitProperty property;
+
+	/** The propertyregex. */
+	String propertyRegex;
+
+	/** The Xmin corpus. */
+	int XminCorpus;
+
+	/** The Xmax corpus. */
+	int XmaxCorpus;
+	
+	/** The writer. */
+	private BufferedWriter writer;
+
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static String black = "black"; //$NON-NLS-1$
+
+	/** The colors. */
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static String[] colors = {"red","blue","green3","gold", "deeppink1", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+		"firebrick","navyblue","green4", "darkgoldenrod1","magenta1", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+		"deepskyblue","green","yellow","cyan","greenyellow", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+		"seagreen1", black, "grey" }; //$NON-NLS-1$ //$NON-NLS-2$ 
+	//int[] colors16 = {552, 26, 257, 142, 117,133 ,491, 258, 76, 451, 121, 254, 652, 68 ,259, 575};
+
+	/** The monocolors. */
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static String[] monocolors = {black, black, black, black, black,
+		black, black, black, black, black,
+		black, black, black, black, black, black }; 
+	//int[] monocolors = {24, 24, 24, 24, 24, 24 ,24, 24, 24, 24, 24, 24, 24, 24 ,24, 24};
+
+	// jeu de 16 couleurs :
+
+	// jeu de 10 couleurs :
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static String[] colors10 = {"red","blue","green4","gold","deeppink1", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+			"firebrick", "deepskyblue","greenyellow", "darkgoldenrod1","magenta1"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+
+	// jeu de 5 couleurs :
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static String[] colors5 = {"red", "blue", "green4", "gold", "deeppink1"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+
+	/** The styles. */
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static int[] styles = {
+		1, 2, 3, 4, 5, 6, 1, 2, 3, 4 ,5, 6 ,1 ,2 ,3, 4 }; 
+
+	/** The monostyles. */
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static int[] monostyles = {
+		1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ,1 ,1 ,1, 1, 1, 1 }; 
+
+
+	/** The widths. */
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static int[] widths = {
+		1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3 }; 
+
+	/** The monowidths. */
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated, related to rendering system
+	public static int[] monowidths = {
+		1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 }; 
+
+
+	/** List of token position in the text. */
+	List<int[]> allPositions = new ArrayList<int[]>();
+
+	/** The structurepositions. */
+	int[] structurePositions = new int[0];
+
+	/** The structurenames. */
+	String[] structureNames = new String[0];
+
+	/** graph boundaries. */
+	int maxY;
+
+	/** The max x. */
+	int maxX;
+
+	/** The name. */
+	String name;
+
+	/** The repeatvalues. */
+	private boolean repeatvalues;
+
+	/** The bande. */
+	private float bande = 0.0f;
+
+	/** The bandemultiplier. */
+	private float bandemultiplier;
+
+	/**
+	 * Instantiates a new progression.
+	 *
+	 * @param corpus the corpus
+	 * @param queries , a curve per query
+	 * @param structure , the structural unit to show
+	 * @param property , the value to display
+	 * @param propertyregex , a selection of the values to display
+	 * @param doCumulative , if true do a cumulative graph, if not compute the density (R
+	 * function)
+	 * @param monochrome the monochrome
+	 * @param monostyle the monostyle
+	 * @param linewidth the linewidth
+	 * @param repeat the repeat
+	 * @param bandemultiplier the bandemultiplier
+	 */
+	@Deprecated
+	// FIXME : to remove when charts engine will be validated
+	// FIXME : all parameters related to rendering should removed from this class and centralized in the charts engine system
+	public Progression(Corpus corpus, List<Query> queries, StructuralUnit structure, StructuralUnitProperty property, String propertyregex,
+			boolean doCumulative, int linewidth, boolean repeat, float bandemultiplier) {
+		//System.out.println("monochrome: "+monochrome+" monostyle: "+monostyle+" width: "+linewidth);
+		this.corpus = corpus; // the corpus which we compute on
+		this.queries = queries; // the query of the selection
+		this.structure = structure;
+		this.property = property;
+		this.propertyRegex = propertyregex;
+		this.repeatvalues = repeat;
+		this.bandemultiplier = bandemultiplier;
+
+		for (int i = 0 ; i < monowidths.length ; i++) {
+			monowidths[i] = linewidth;
+		}
+	}
+
+	/**
+	 * Compute.
+	 *
+	 * @return true, if successful
+	 * @throws CqiClientException the cqi client exception
+	 * @throws CqiServerError 
+	 * @throws IOException 
+	 */
+	public boolean process() throws CqiClientException, IOException, CqiServerError {
+		return stepQueries() && stepStructuralUnits() && stepFinalize();
+	}
+
+	/**
+	 * Test discontinuity of a corpus. If the corpus is a subcorpus then test if the start-end of matches make no hole
+	 * @param corpus
+	 * @return
+	 */
+	public static boolean canRunProgression(Corpus corpus) {
+		//System.out.println(corpus.getMatches());
+		if (corpus.getMatches().size() == 1) return true;
+		else {
+			Match previousMatch = null;
+			for (Match m : corpus.getMatches()) {
+				if (previousMatch == null) {
+					previousMatch = m;
+					continue;
+				}
+				
+				if (m.getStart() == previousMatch.getEnd()+1) {
+					previousMatch = m;
+					continue;
+				} else {
+					return false;
+				}
+			}
+		}
+		return true;
+	}
+
+	/**
+	 * Step queries.
+	 *
+	 * @throws CqiClientException the cqi client exception
+	 */
+	public boolean stepQueries() throws CqiClientException
+	{
+		maxX = corpus.getSize();
+		int npositions = 0;
+		for (Query query : queries) {
+			// System.out.println("query  "+query.getQueryString());
+			QueryResult result = corpus.query(query, query.getQueryString()
+					.replace(" ", "_") + "_progression", true); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$			
+			int nLines = result.getNMatch();
+			if (maxY < nLines)
+				maxY = nLines;
+
+			List<Match> matches = null;
+			if (nLines > 0) {
+				matches = result.getMatches(0, nLines - 1); // get the indexes
+				// sequences of result's tokens
+			} else {
+				matches = new ArrayList<Match>();
+			}
+			//System.out.println("matches: "+matches);
+			int[] positions = new int[matches.size()];
+			// System.out.println("nb positions "+matches.size());
+			// if (matches.size() > 0)
+			allPositions.add(positions);
+			int i = 0;
+			for (Match m : matches) {
+				positions[i++] = m.getStart();
+				npositions++;
+			}
+			result.drop();
+		}
+		return npositions > 0;
+	}
+
+	/**
+	 * Step structural units.
+	 *
+	 * @throws CqiClientException the cqi client exception
+	 * @throws CqiServerError 
+	 * @throws IOException 
+	 */
+	public boolean stepStructuralUnits() throws CqiClientException, IOException, CqiServerError
+	{
+		// structure query
+		if (structure != null) {
+			Query query = new Query("<" + structure.getName() + ">[]"); //$NON-NLS-1$ //$NON-NLS-2$
+			if (property != null) {
+				query = new Query("<" + property.getFullName() + ">[]"); //$NON-NLS-1$ //$NON-NLS-2$
+				if (propertyRegex != null)
+					query = new Query(
+							"<"	+ property.getFullName() + "=\"" + propertyRegex + "\">[]"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			}
+
+			// System.out.println("Struct: "+ structure+" property: "+property);
+			// System.out.println(query.getQueryString());
+			QueryResult result = corpus.query(query, query.getQueryString()
+					.replace(" ", "_") + "_progression", true); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			int[] starts = result.getStarts();
+			result.drop();
+			int nLines = starts.length;
+			
+//			List<Match> matches = new ArrayList<Match>();
+//			if (nLines > 0)
+//				matches = result.getMatches(0, nLines - 1); // get the indexes
+			// sequences of result's tokens
+
+			structurePositions = new int[nLines];
+			structureNames = new String[nLines];
+
+			
+			
+			Map<Property, List<String>> refValues = new HashMap<Property, List<String>>();
+			if (property != null) {
+				List<String> values = CorpusManager.getCorpusManager().getCqiClient().getSingleData(property, starts);
+				refValues.put(property, values);
+			}
+
+			int i = 0;
+			String previousname = ""; //$NON-NLS-1$
+			String currentname = ""; //$NON-NLS-1$
+			int previousposition = -99999;
+			int distmin = 999999;
+			for (int m : starts) {
+				if (property != null)
+					currentname = refValues.get(property).get(i);
+				else
+					currentname = structure.getName() + i;
+
+				if (repeatvalues) {
+					structureNames[i] = currentname;
+					structurePositions[i] = m;
+				} else {
+					if (!previousname.equals(currentname)) {
+						structureNames[i] = currentname;
+						structurePositions[i] = m;
+					}
+				}
+				if (i == 0)
+					structurePositions[i] += 1; 
+
+				if (m - previousposition < distmin) {
+					distmin = m - previousposition;
+				}
+
+				previousname = ""+currentname; //$NON-NLS-1$
+				previousposition = m;
+
+				i++;
+			}
+			this.bande = distmin*bandemultiplier;
+		}
+		return true;
+	}
+
+	/**
+	 * Step finalize.
+	 *
+	 * @throws CqiClientException the cqi client exception
+	 */
+	public boolean stepFinalize() throws CqiClientException
+	{
+		if (corpus instanceof Subcorpus) {
+			List<Match> matches = ((Subcorpus) corpus).getMatches();
+			if (matches.size() == 0) {
+				System.out.println(Messages.Progression_1);
+				return false;
+			}
+			
+			XminCorpus = matches.get(0).getStart();
+			XmaxCorpus = matches.get(matches.size()-1).getEnd();		
+		} else {
+			XminCorpus = 0;
+			XmaxCorpus = corpus.getSize();
+		}
+		//System.out.println("min: "+XminCorpus+ "max: "+XmaxCorpus);
+
+		if (bande <= 0) {
+			bande = ((XmaxCorpus - XminCorpus)/100)*bandemultiplier;
+			if (bande == 0)
+				bande = 1.0f;
+		}
+		return true;
+	}
+
+	/** The norep. */
+	public static int norep = 1;
+
+	/** The prefix r. */
+	public static String prefixR = "Progression"; //$NON-NLS-1$
+
+
+	/**
+	 * 
+	 * @param outfile
+	 * @param encoding
+	 * @return
+	 * @throws IOException
+	 */
+	public boolean toTxt(File outfile, String encoding) throws IOException {
+		// NK: writer declared as class attribute to perform a clean if the operation is interrupted
+		tryAcquireSemaphore();
+		this.writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfile),
+				encoding)); 
+		for (int i = 0 ; i < queries.size() ; i++) {
+			writer.write("* "+queries.get(i)+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			for (int p : allPositions.get(i)) {
+				writer.write(""+p+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
+			}
+		}
+		writer.close();
+		releaseSemaphore();
+		return true;
+	}
+	
+
+
+
+
+	/**
+	 * Gets the max x.
+	 *
+	 * @return the max x
+	 */
+	public int getMaxX() {
+		return maxX;
+	}
+
+	/**
+	 * Gets the max y.
+	 *
+	 * @return the max y
+	 */
+	public int getMaxY() {
+		return maxY;
+	}
+
+	/**
+	 * Gets the corpus.
+	 *
+	 * @return the corpus
+	 */
+	public Corpus getCorpus() {
+		return corpus;
+	}
+
+	/**
+	 * Gets the queries.
+	 *
+	 * @return the queries
+	 */
+	public List<Query> getQueries() {
+		return queries;
+	}
+
+	/**
+	 * Gets the allpositions.
+	 *
+	 * @return the allpositions
+	 */
+	public List<int[]> getAllpositions() {
+		return allPositions;
+	}
+
+	/**
+	 * Gets the positions counts.
+	 *
+	 * @return the positions counts
+	 */
+	public List<Integer> getPositionsCounts() {
+		ArrayList<Integer> counts = new ArrayList<Integer>();
+		for (int[] list : allPositions)
+			counts.add(list.length);
+		return counts;
+	}
+
+	/**
+	 * Gets the name.
+	 *
+	 * @return the name
+	 */
+	public String getName() {
+		return this.queries.toString();
+	}
+
+	/**
+	 * Gets the details.
+	 *
+	 * @return the details
+	 */
+	public String getDetails() {
+		return this.queries.toString();
+	}
+
+	
+	/**
+	 * Checks if is repeatvalues.
+	 *
+	 * @return true, if is repeatvalues
+	 */
+	public boolean isRepeatvalues() {
+		return repeatvalues;
+	}
+
+
+
+	@Override
+	public void clean() {
+		try {
+			this.writer.flush();
+			this.writer.close();	
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			org.txm.utils.logger.Log.printStackTrace(e);
+		}
+	}
+
+	@Override
+	public boolean toTxt(File outfile, String encoding, String colseparator,
+			String txtseparator) throws Exception {
+		return toTxt(outfile, encoding);
+	}
+
+	/**
+	 * @return the allPositions
+	 */
+	public List<int[]> getAllPositions() {
+		return allPositions;
+	}
+
+	/**
+	 * @return the structurePositions
+	 */
+	public int[] getStructurePositions() {
+		return structurePositions;
+	}
+
+	/**
+	 * @return the structureNames
+	 */
+	public String[] getStructureNames() {
+		return structureNames;
+	}
+
+	/**
+	 * @return the structure
+	 */
+	public StructuralUnit getStructure() {
+		return structure;
+	}
+
+	/**
+	 * @return the property
+	 */
+	public StructuralUnitProperty getProperty() {
+		return property;
+	}
+
+	/**
+	 * @return the propertyRegex
+	 */
+	public String getPropertyRegex() {
+		return propertyRegex;
+	}
+
+	/**
+	 * @return the bande
+	 */
+	public float getBande() {
+		return bande;
+	}
+
+	/**
+	 * @return the xminCorpus
+	 */
+	public int getXminCorpus() {
+		return XminCorpus;
+	}
+
+	/**
+	 * @return the xmaxCorpus
+	 */
+	public int getXmaxCorpus() {
+		return XmaxCorpus;
+	}
+
+
+
+	/**
+	 * @param name the name to set
+	 */
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	@Override
+	public String[] getExportTXTExtensions() {
+		return new String[]{"*.txt"};
+	}
+
+	@Override
+	public boolean delete() {
+		return corpus.removeResult(this);
+	}
+
+	@Override
+	public HasResults getParent() {
+		return corpus;
+	}
+
+	/**
+	 * Computes and gets a query constructed from all the queries in alternative mode (with pipe |).
+	 * @return
+	 */
+	public String getQueriesString()	{
+		ArrayList<Integer> allQueriesIndexes = new ArrayList<Integer>(this.queries.size());
+		for(int i = 0; i < this.queries.size(); i++) {
+			allQueriesIndexes.add(i);
+		}
+		return this.getQueriesString(allQueriesIndexes) ;
+	}
+	
+	/**
+	 * Computes and gets a query constructed from all the queries specified by their index in alternative mode (with pipe |).
+	 * @param queriesIndexes
+	 * @return
+	 */
+	public String getQueriesString(ArrayList<Integer> queriesIndexes)	{
+		
+		String query = "";
+		
+		for(int i = 0; i < this.queries.size(); i++) {
+			if(queriesIndexes.contains(i))	{
+				String tmpQuery = this.queries.get(i).getQueryString();
+				// Remove "[" and "]" only if it's a simple query as "[look]" 
+				if(tmpQuery.startsWith("[") && !tmpQuery.contains("="))	{
+					int length = tmpQuery.length();
+					if(tmpQuery.endsWith("]"))	{
+						length--;
+					}
+					tmpQuery = tmpQuery.substring(1, length);
+				}
+				if(query.length() > 0)	{
+					query += " | ";
+				}
+				query += tmpQuery;
+			}
+		}
+
+		return query;
+		
+	}
+}

Index: tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/base/ProgressionChartCreator.java
===================================================================
--- tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/base/ProgressionChartCreator.java	(revision 0)
+++ tmp/org.txm.progression.core/src/org/txm/progression/core/chartsengine/base/ProgressionChartCreator.java	(revision 137)
@@ -0,0 +1,53 @@
+/**
+ * 
+ */
+package org.txm.progression.core.chartsengine.base;
+
+import java.util.ArrayList;
+
+/**
+ * Progression chart creator interface.
+ * @author sjacquot
+ *
+ */
+public interface ProgressionChartCreator {
+
+	/**
+	 * Gets the positions of the points currently selected in the Progression step chart.
+	 * @param chart
+	 * @return
+	 */
+	public abstract ArrayList<Integer> getSelectedPointPositions(Object chart);
+	
+	/**
+	 * Gets the numbers of item in series of the selected points.
+	 * @param chart
+	 * @return
+	 */
+	public abstract ArrayList<Integer> getSelectedPointNumbers(Object chart);
+	
+	
+	/**
+	 * Gets the positions of all the points in the Progression step chart grouped by series.
+	 * @param chart
+	 * @return
+	 */
+	public abstract ArrayList<ArrayList<Integer>> getAllPointPositionsBySeries(Object chart);
+
+	
+	/**
+	 * Gets the selected series indexes.
+	 * @param chart
+	 * @return
+	 */
+	public abstract ArrayList<Integer> getSelectedSeries(Object chart);
+	
+	/**
+	 * Gets the last selected series.
+	 * @param chart
+	 * @return
+	 */
+	public abstract int getLastSelectedSeries(Object chart);
+
+	
+}

